package cz.novoj.log;

import cz.novoj.business.interceptor.NaiveSecurityInterceptor;

/**
 * Log4J appender optimalized to verify security checks before method is called.
 *
 * @author Jan Novotn, FG Forrest a.s. (c) 2007
 * @version $Id: $
 */
public class CustomSecurityTestAppender extends CustomAppender {

	public CustomSecurityTestAppender() {
		super(NaiveSecurityInterceptor.class);
	}

	public boolean isBlocked(Class forClass, String forMethod) {
		return containsExactSingleLogRecord("Method call [" + forClass.getName() + "." + forMethod + "]] was blocked.");
	}

	public boolean isAllowed(Class forClass, String forMethod) {
		return containsExactSingleLogRecord("Method call [" + forClass.getName() + "." + forMethod + "]] was allowed.");
	}

}